﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Class cStoreAccount

    Const ROOT_PATH As String = "AccountInfo\"

    Public Shared Function AddAccountInfo(ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sServerAddr As String, ByVal nServerPort As Integer, ByVal nServerType As Integer, ByVal bRegSIP As Boolean) As Boolean

        Dim objStore As cStoreRegistry = New cStoreRegistry()
        Dim sKeyPath As String = ROOT_PATH & sUserName

        objStore.SetTEXT(sKeyPath, "VaxDisplayName", sDisplayName)
        objStore.SetTEXT(sKeyPath, "VaxUserName", sUserName)

        objStore.SetTEXT(sKeyPath, "VaxAuthLogin", sAuthLogin)
        objStore.SetTEXT(sKeyPath, "VaxAuthPassword", sAuthPwd)

        objStore.SetTEXT(sKeyPath, "VaxDomainRealm", sDomainRealm)
        objStore.SetTEXT(sKeyPath, "VaxServerAddr", sServerAddr)
        objStore.SetINT(sKeyPath, "VaxServerPort", nServerPort)

        objStore.SetINT(sKeyPath, "VaxServerType", nServerType)
        objStore.SetBOOL(sKeyPath, "VaxRegisterSIP", bRegSIP)

        objStore.Close()
        Return True

    End Function

    Public Shared Sub GetAccountInfo(ByRef sDisplayName As String, ByRef sUserName As String, ByRef sAuthLogin As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sServerAddr As String, ByRef nServerPort As Integer, ByRef nServerType As Integer, ByRef bRegSIP As Boolean)

        Dim objStore As cStoreRegistry = New cStoreRegistry()
        Dim sKeyPath As String = ROOT_PATH & sUserName

        objStore.GetTEXT(sKeyPath, "VaxDisplayName", sDisplayName, "")
        objStore.GetTEXT(sKeyPath, "VaxUserName", sUserName, "")

        objStore.GetTEXT(sKeyPath, "VaxAuthLogin", sAuthLogin, "")
        objStore.GetTEXT(sKeyPath, "VaxAuthPassword", sAuthPwd, "")

        objStore.GetTEXT(sKeyPath, "VaxDomainRealm", sDomainRealm, "")
        objStore.GetTEXT(sKeyPath, "VaxServerAddr", sServerAddr, "")
        objStore.GetINT(sKeyPath, "VaxServerPort", nServerPort, 5060)

        objStore.GetINT(sKeyPath, "VaxServerType", nServerType, cVaxSIPUserAgentCOM.VAX_ACCOUNT_TYPE_UDP)
        objStore.GetBOOL(sKeyPath, "VaxRegisterSIP", bRegSIP, True)

        objStore.Close()

    End Sub

End Class
