﻿
Imports System.Runtime.InteropServices
Imports VAXSIPUSERAGENTCOMLib

Public Class cVaxSIPUserAgentCOM

    Public Const VAX_ACCOUNT_TYPE_UDP As Integer = 0
    Public Const VAX_ACCOUNT_TYPE_TCP As Integer = 1
    Public Const VAX_ACCOUNT_TYPE_TLS As Integer = 2

    Public Const VAX_VIDEO_QUALITY_LOW As Integer = 0
    Public Const VAX_VIDEO_QUALITY_STANDARD As Integer = 1
    Public Const VAX_VIDEO_QUALITY_MEDIUM As Integer = 2
    Public Const VAX_VIDEO_QUALITY_HIGH As Integer = 3
    Public Const VAX_VIDEO_QUALITY_MAX As Integer = 4

    Public Const VAX_AUDIO_CODEC_G711U As Integer = 0
    Public Const VAX_AUDIO_CODEC_G711A As Integer = 1
    Public Const VAX_AUDIO_CODEC_GSM610 As Integer = 2
    Public Const VAX_AUDIO_CODEC_ILBC As Integer = 3
    Public Const VAX_AUDIO_CODEC_G729 As Integer = 4

    Public Const VAX_VIDEO_CODEC_VP8 As Integer = 0

    Public Const VAX_DTMF_TYPE_AUTO As Integer = 0
    Public Const VAX_DTMF_TYPE_RFC2833 As Integer = 1
    Public Const VAX_DTMF_TYPE_SIP_INFO As Integer = 2
    Public Const VAX_DTMF_TYPE_INBAND As Integer = 3

    Public Const VAX_CAPTURE_SOUND_DEVICE_NONE As Integer = -2

    Public Const VAX_CONTACT_STATUS_ONLINE As Integer = 0
    Public Const VAX_CONTACT_STATUS_OFFLINE As Integer = 1
    Public Const VAX_CONTACT_STATUS_AWAY As Integer = 2
    Public Const VAX_CONTACT_STATUS_ON_PHONE As Integer = 3
    Public Const VAX_CONTACT_STATUS_BUSY As Integer = 4
    Public Const VAX_CONTACT_STATUS_UNKNOWN As Integer = 5

    Public Const VAX_BUSY_LAMP_STATUS_FREE As Integer = 0
    Public Const VAX_BUSY_LAMP_STATUS_OFFLINE As Integer = 1
    Public Const VAX_BUSY_LAMP_STATUS_BUSY As Integer = 2
    Public Const VAX_BUSY_LAMP_STATUS_UNKNOWN As Integer = 3
    Public Const VAX_BUSY_LAMP_STATUS_CONNECTING As Integer = 4

    Public Const VAX_INCOMING_CALL_ACCEPTED As Integer = 0
    Public Const VAX_INCOMING_CALL_REJECTED As Integer = 1
    Public Const VAX_INCOMING_CALL_CANCELED As Integer = 2


    Private m_objVaxVoIP As VaxVoIPSIP = New VaxVoIPSIP()

    Public Sub New()

        AddHandler m_objVaxVoIP.OnInitialized, AddressOf OnInitialized
        AddHandler m_objVaxVoIP.OnUnInitialized, AddressOf OnUnInitialized

        AddHandler m_objVaxVoIP.OnConnectingToRegister, AddressOf OnConnectingToRegister
        AddHandler m_objVaxVoIP.OnTryingToRegister, AddressOf OnTryingToRegister
        AddHandler m_objVaxVoIP.OnFailToRegister, AddressOf OnFailToRegister
        AddHandler m_objVaxVoIP.OnSuccessToRegister, AddressOf OnSuccessToRegister
        AddHandler m_objVaxVoIP.OnConnectingToReRegister, AddressOf OnConnectingToReRegister
        AddHandler m_objVaxVoIP.OnTryingToReRegister, AddressOf OnTryingToReRegister
        AddHandler m_objVaxVoIP.OnFailToReRegister, AddressOf OnFailToReRegister
        AddHandler m_objVaxVoIP.OnSuccessToReRegister, AddressOf OnSuccessToReRegister
        AddHandler m_objVaxVoIP.OnTryingToUnRegister, AddressOf OnTryingToUnRegister
        AddHandler m_objVaxVoIP.OnFailToUnRegister, AddressOf OnFailToUnRegister
        AddHandler m_objVaxVoIP.OnSuccessToUnRegister, AddressOf OnSuccessToUnRegister

        AddHandler m_objVaxVoIP.OnDialCallStarted, AddressOf OnDialCallStarted
        AddHandler m_objVaxVoIP.OnDialingCall, AddressOf OnDialingCall
        AddHandler m_objVaxVoIP.OnDialCallFailed, AddressOf OnDialCallFailed
        AddHandler m_objVaxVoIP.OnConnectedCall, AddressOf OnConnectedCall
        AddHandler m_objVaxVoIP.OnHungupCall, AddressOf OnHungupCall

        AddHandler m_objVaxVoIP.OnIncomingCallStarted, AddressOf OnIncomingCallStarted
        AddHandler m_objVaxVoIP.OnIncomingCallEnded, AddressOf OnIncomingCallEnded
        AddHandler m_objVaxVoIP.OnRingToneStarted, AddressOf OnRingToneStarted
        AddHandler m_objVaxVoIP.OnRingToneEnded, AddressOf OnRingToneEnded

        AddHandler m_objVaxVoIP.OnTransferCallAccepted, AddressOf OnTransferCallAccepted
        AddHandler m_objVaxVoIP.OnTransferCallFailed, AddressOf OnTransferCallFailed

        AddHandler m_objVaxVoIP.OnPlayWaveDone, AddressOf OnPlayWaveDone
        AddHandler m_objVaxVoIP.OnDigitDTMF, AddressOf OnDigitDTMF
        AddHandler m_objVaxVoIP.OnMsgNOTIFY, AddressOf OnMsgNOTIFY

        AddHandler m_objVaxVoIP.OnVoiceMailMsg, AddressOf OnVoiceMailMsg
        AddHandler m_objVaxVoIP.OnIncomingDiagnostic, AddressOf OnIncomingDiagnostic
        AddHandler m_objVaxVoIP.OnOutgoingDiagnostic, AddressOf OnOutgoingDiagnostic

        AddHandler m_objVaxVoIP.OnAudioSessionLost, AddressOf OnAudioSessionLost
        AddHandler m_objVaxVoIP.OnSuccessToHold, AddressOf OnSuccessToHold
        AddHandler m_objVaxVoIP.OnTryingToHold, AddressOf OnTryingToHold
        AddHandler m_objVaxVoIP.OnFailToHold, AddressOf OnFailToHold
        AddHandler m_objVaxVoIP.OnSuccessToUnHold, AddressOf OnSuccessToUnHold
        AddHandler m_objVaxVoIP.OnTryingToUnHold, AddressOf OnTryingToUnHold
        AddHandler m_objVaxVoIP.OnFailToUnHold, AddressOf OnFailToUnHold

        AddHandler m_objVaxVoIP.OnTryingToRefresh, AddressOf OnTryingToRefresh
        AddHandler m_objVaxVoIP.OnFailToRefresh, AddressOf OnFailToRefresh
        AddHandler m_objVaxVoIP.OnSuccessToRefresh, AddressOf OnSuccessToRefresh

        AddHandler m_objVaxVoIP.OnChatSubscribeSuccess, AddressOf OnChatSubscribeSuccess
        AddHandler m_objVaxVoIP.OnChatSubscribeFailed, AddressOf OnChatSubscribeFailed

        AddHandler m_objVaxVoIP.OnChatContactStatus, AddressOf OnChatContactStatus
        AddHandler m_objVaxVoIP.OnChatSendMsgTextSuccess, AddressOf OnChatSendMsgTextSuccess
        AddHandler m_objVaxVoIP.OnChatSendMsgTextFailed, AddressOf OnChatSendMsgTextFailed
        AddHandler m_objVaxVoIP.OnChatSendMsgTypingSuccess, AddressOf OnChatSendMsgTypingSuccess
        AddHandler m_objVaxVoIP.OnChatSendMsgTypingFailed, AddressOf OnChatSendMsgTypingFailed

        AddHandler m_objVaxVoIP.OnChatRecvMsgText, AddressOf OnChatRecvMsgText
        AddHandler m_objVaxVoIP.OnChatRecvMsgTypingStart, AddressOf OnChatRecvMsgTypingStart
        AddHandler m_objVaxVoIP.OnChatRecvMsgTypingStop, AddressOf OnChatRecvMsgTypingStop

        AddHandler m_objVaxVoIP.OnDetectedAMD, AddressOf OnDetectedAMD

        AddHandler m_objVaxVoIP.OnHoldCall, AddressOf OnHoldCall
        AddHandler m_objVaxVoIP.OnUnHoldCall, AddressOf OnUnHoldCall

        AddHandler m_objVaxVoIP.OnVideoDeviceFrameRGB, AddressOf OnVideoDeviceFrameRGB
        AddHandler m_objVaxVoIP.OnVideoRemoteFrameRGB, AddressOf OnVideoRemoteFrameRGB

        AddHandler m_objVaxVoIP.OnVideoRemoteStarted, AddressOf OnVideoRemoteStarted
        AddHandler m_objVaxVoIP.OnVideoRemoteEnded, AddressOf OnVideoRemoteEnded

        AddHandler m_objVaxVoIP.OnAddCallHistory, AddressOf OnAddCallHistory
        AddHandler m_objVaxVoIP.OnNetworkReachability, AddressOf OnNetworkReachability

        AddHandler m_objVaxVoIP.OnAudioDeviceMicVU, AddressOf OnAudioDeviceMicVU
        AddHandler m_objVaxVoIP.OnAudioDeviceSpkVU, AddressOf OnAudioDeviceSpkVU

        AddHandler m_objVaxVoIP.OnVaxErrorMsg, AddressOf OnVaxErrorMsg

        AddHandler m_objVaxVoIP.OnBusyLampSubscribeSuccess, AddressOf OnBusyLampSubscribeSuccess
        AddHandler m_objVaxVoIP.OnBusyLampSubscribeFailed, AddressOf OnBusyLampSubscribeFailed
        AddHandler m_objVaxVoIP.OnBusyLampContactStatus, AddressOf OnBusyLampContactStatus

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////

    Public Function GetVersionSDK() As String
        Return m_objVaxVoIP.GetVersionSDK()
    End Function

    Public Function GetVersionFile() As String
        Return m_objVaxVoIP.GetVersionFile()
    End Function

    Public Function SetLicenceKey(ByVal sLicenceKey As String) As Boolean
        Return m_objVaxVoIP.SetLicenceKey(sLicenceKey)
    End Function

    Public Function GetCallId(ByVal nLineNo As Integer) As String
        Return m_objVaxVoIP.GetCallId(nLineNo)
    End Function

    Public Function AudioDeviceVU(ByVal bActivate As Boolean, ByVal bMicVU As Boolean, ByVal bSpkVU As Boolean) As Boolean
        Return m_objVaxVoIP.AudioDeviceVU(bActivate, bMicVU, bSpkVU)
    End Function

    Public Function GetAudioInDevTotal() As Integer
        Return m_objVaxVoIP.GetAudioInDevTotal()
    End Function

    Public Function GetAudioOutDevTotal() As Integer
        Return m_objVaxVoIP.GetAudioOutDevTotal()
    End Function

    Public Function GetAudioInDevName(ByVal nDeviceId As Integer) As String
        Return m_objVaxVoIP.GetAudioInDevName(nDeviceId)
    End Function

    Public Function GetAudioOutDevName(ByVal nDeviceId As Integer) As String
        Return m_objVaxVoIP.GetAudioOutDevName(nDeviceId)
    End Function

    Public Function Initialize() As Boolean
        Return m_objVaxVoIP.Initialize()
    End Function

    Public Sub UnInitialize()
        m_objVaxVoIP.UnInitialize()
    End Sub

    Public Function AddAccountSIP(ByVal sAccountName As String, ByVal nAccountType As Integer, ByVal sListenIP As String, ByVal nListenPort As Integer, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sServerAddr As String, ByVal nServerPort As Integer) As Boolean
        Return m_objVaxVoIP.AddAccountSIP(sAccountName, nAccountType, sListenIP, nListenPort, sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort)
    End Function

    Public Sub RemoveAccountSIP(ByVal sAccountName As String)
        m_objVaxVoIP.RemoveAccountSIP(sAccountName)
    End Sub

    Public Function RegisterAccountSIP(ByVal sAccountName As String, ByVal nExpire As Integer) As Boolean
        Return m_objVaxVoIP.RegisterAccountSIP(sAccountName, nExpire)
    End Function

    Public Function UnRegisterAccountSIP(ByVal sAccountName As String) As Boolean
        Return m_objVaxVoIP.UnRegisterAccountSIP(sAccountName)
    End Function

    Public Function OpenLine(ByVal nLineNo As Integer, ByVal sRTPRxIP As String, ByVal nRxAudioPortRTP As Integer, ByVal nRxVideoPortRTP As Integer) As Boolean
        Return m_objVaxVoIP.OpenLine(nLineNo, sRTPRxIP, nRxAudioPortRTP, nRxVideoPortRTP)
    End Function

    Public Function OpenLineREC(ByVal nLineNo As Integer, ByVal sRTPRxIP As String, ByVal nAudioPortRTP As Integer) As Boolean
        Return m_objVaxVoIP.OpenLineREC(nLineNo, sRTPRxIP, nAudioPortRTP)
    End Function

    Public Function CloseLine(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.CloseLine(nLineNo)
    End Function

    Public Function GetVaxErrorCode() As Integer
        Return m_objVaxVoIP.GetVaxErrorCode()
    End Function

    Public Function GetVaxErrorMsg() As String
        Return m_objVaxVoIP.GetVaxErrorMsg()
    End Function

    Public Function DialCall(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nnInputDeviceId As Integer, ByVal nnOutputDeviceId As Integer) As Boolean
        Return m_objVaxVoIP.DialCall(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo, nnInputDeviceId, nnOutputDeviceId)
    End Function

    Public Function DisconnectCall(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.DisconnectCall(nLineNo)
    End Function

    Public Function AcceptCall(ByVal nLineNo As Integer, ByVal sCallId As String, ByVal nInputDeviceId As Integer, ByVal nOutputDeviceId As Integer) As Boolean
        Return m_objVaxVoIP.AcceptCall(nLineNo, sCallId, nInputDeviceId, nOutputDeviceId)
    End Function

    Public Function RejectCall(ByVal sCallId As String) As Boolean
        Return m_objVaxVoIP.RejectCall(sCallId)
    End Function

    Public Function TransferCallBlind(ByVal nLineNo As Integer, ByVal sToUserName As String) As Boolean
        Return m_objVaxVoIP.TransferCallBlind(nLineNo, sToUserName)
    End Function

    Public Function TransferCallConsult(ByVal nLineNoA As Integer, ByVal nLineNoB As Integer) As Boolean
        Return m_objVaxVoIP.TransferCallConsult(nLineNoA, nLineNoB)
    End Function

    Public Function HoldLine(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.HoldLine(nLineNo)
    End Function

    Public Function UnHoldLine(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.UnHoldLine(nLineNo)
    End Function

    Public Function RefreshLine(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.RefreshLine(nLineNo)
    End Function

    Public Function IsLineOpen(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.IsLineOpen(nLineNo)
    End Function

    Public Function IsLineHold(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.IsLineHold(nLineNo)
    End Function

    Public Function IsLineBusy(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.IsLineBusy(nLineNo)
    End Function

    Public Function IsLineConnected(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.IsLineConnected(nLineNo)
    End Function

    Public Function EnableKeepAlive(ByVal sAccountName As String, ByVal nSeconds As Integer) As Boolean
        Return m_objVaxVoIP.EnableKeepAlive(sAccountName, nSeconds)
    End Function

    Public Sub DisableKeepAlive(ByVal sAccountName As String)
        m_objVaxVoIP.DisableKeepAlive(sAccountName)
    End Sub

    Public Sub DeselectAllAudioCodec()
        m_objVaxVoIP.DeselectAllAudioCodec()
    End Sub

    Public Sub SelectAllAudioCodec()
        m_objVaxVoIP.SelectAllAudioCodec()
    End Sub

    Public Function SelectAudioCodec(ByVal nCodecNo As Integer) As Boolean
        Return m_objVaxVoIP.SelectAudioCodec(nCodecNo)
    End Function

    Public Function DeselectAudioCodec(ByVal nCodecNo As Integer) As Boolean
        Return m_objVaxVoIP.DeselectAudioCodec(nCodecNo)
    End Function

    Public Sub DeselectAllVideoCodec()
        m_objVaxVoIP.DeselectAllVideoCodec()
    End Sub

    Public Sub SelectAllVideoCodec()
        m_objVaxVoIP.SelectAllVideoCodec()
    End Sub

    Public Function SelectVideoCodec(ByVal nCodecNo As Integer) As Boolean
        Return m_objVaxVoIP.SelectVideoCodec(nCodecNo)
    End Function

    Public Sub DeselectVideoCodec(ByVal nCodecNo As Integer)
        m_objVaxVoIP.DeselectVideoCodec(nCodecNo)
    End Sub

    Public Function DigitDTMF(ByVal nLineNo As Integer, ByVal sDigit As String, ByVal nTypeDTMF As Integer) As Boolean
        Return m_objVaxVoIP.DigitDTMF(nLineNo, sDigit, nTypeDTMF)
    End Function

    Public Function SetVolumeDTMF(ByVal nVolume As Integer) As Boolean
        Return m_objVaxVoIP.SetVolumeDTMF(nVolume)
    End Function

    Public Function GetVolumeDTMF() As Integer
        Return m_objVaxVoIP.GetVolumeDTMF()
    End Function

    Public Function MuteMic(ByVal bMute As Boolean) As Boolean
        Return m_objVaxVoIP.MuteMic(bMute)
    End Function

    Public Function MuteSpk(ByVal bMute As Boolean) As Boolean
        Return m_objVaxVoIP.MuteSpk(bMute)
    End Function

    Public Function MuteLineSpk(ByVal nLineNo As Integer, ByVal bMute As Boolean) As Boolean
        Return m_objVaxVoIP.MuteLineSpk(nLineNo, bMute)
    End Function

    Public Function MuteLineMic(ByVal nLineNo As Integer, ByVal bMute As Boolean) As Boolean
        Return m_objVaxVoIP.MuteLineMic(nLineNo, bMute)
    End Function

    Public Function AutoGainMic(ByVal bEnable As Boolean, ByVal nVolume As Integer) As Boolean
        Return m_objVaxVoIP.AutoGainMic(bEnable, nVolume)
    End Function

    Public Function AutoGainSpk(ByVal bEnable As Boolean, ByVal nVolume As Integer) As Boolean
        Return m_objVaxVoIP.AutoGainSpk(bEnable, nVolume)
    End Function

    Public Function SetVolumeMic(ByVal nVolume As Integer) As Boolean
        Return m_objVaxVoIP.SetVolumeMic(nVolume)
    End Function

    Public Function GetVolumeMic() As Integer
        Return m_objVaxVoIP.GetVolumeMic()
    End Function

    Public Function SetVolumeSpk(ByVal nVolume As Integer) As Boolean
        Return m_objVaxVoIP.SetVolumeSpk(nVolume)
    End Function

    Public Function GetVolumeSpk() As Integer
        Return m_objVaxVoIP.GetVolumeSpk()
    End Function

    Public Function SetLineVolumeSpk(ByVal nLineNo As Integer, ByVal nVolume As Integer) As Boolean
        Return m_objVaxVoIP.SetLineVolumeSpk(nLineNo, nVolume)
    End Function

    Public Function GetLineVolumeSpk(ByVal nLineNo As Integer) As Integer
        Return m_objVaxVoIP.GetLineVolumeSpk(nLineNo)
    End Function

    Public Function EchoCancellation(ByVal bEnable As Boolean) As Boolean
        Return m_objVaxVoIP.EchoCancellation(bEnable)
    End Function

    Public Function DonotDisturb(ByVal bEnable As Boolean) As Boolean
        Return m_objVaxVoIP.DonotDisturb(bEnable)
    End Function

    Public Function IsLineRecording(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.IsLineRecording(nLineNo)
    End Function

    Public Function StartRecording(ByVal nLineNo As Integer, ByVal sFileName As String, ByVal nTypeRecord As Integer, ByVal nTypePCM As Integer) As Boolean
        Return m_objVaxVoIP.StartRecording(nLineNo, sFileName, nTypeRecord, nTypePCM)
    End Function

    Public Function StopRecording(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.StopRecording(nLineNo)
    End Function

    Public Function ResetRecording(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.ResetRecording(nLineNo)
    End Function

    Public Function IsLinePlaying(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.IsLinePlaying(nLineNo)
    End Function

    Public Function PlayWaveOpen(ByVal nLineNo As Integer, ByVal sFileName As String) As Boolean
        Return m_objVaxVoIP.PlayWaveOpen(nLineNo, sFileName)
    End Function

    Public Function PlayWaveClose(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.PlayWaveClose(nLineNo)
    End Function

    Public Function PlayWaveSkipTo(ByVal nLineNo As Integer, ByVal nSeconds As Integer) As Boolean
        Return m_objVaxVoIP.PlayWaveSkipTo(nLineNo, nSeconds)
    End Function

    Public Function PlayWaveTotalTime(ByVal nLineNo As Integer) As Integer
        Return m_objVaxVoIP.PlayWaveTotalTime(nLineNo)
    End Function

    Public Function PlayWavePause(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.PlayWavePause(nLineNo)
    End Function

    Public Function PlayWaveStart(ByVal nLineNo As Integer, ByVal bListen As Boolean) As Boolean
        Return m_objVaxVoIP.PlayWaveStart(nLineNo, bListen)
    End Function

    Public Function PlayWaveStop(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.PlayWaveStop(nLineNo)
    End Function

    Public Function PlayWavePosition(ByVal nLineNo As Integer) As Integer
        Return m_objVaxVoIP.PlayWavePosition(nLineNo)
    End Function

    Public Function GetOutboundCodec(ByVal nLineNo As Integer) As Integer
        Return m_objVaxVoIP.GetOutboundCodec(nLineNo)
    End Function

    Public Function GetInboundCodec(ByVal nLineNo As Integer) As Integer
        Return m_objVaxVoIP.GetInboundCodec(nLineNo)
    End Function

    Public Function SetSessionLostTick(ByVal nSeconds As Integer) As Boolean
        Return m_objVaxVoIP.SetSessionLostTick(nSeconds)
    End Function

    Public Function SetUserAgentSIP(ByVal sUserAgentName As String) As Boolean
        Return m_objVaxVoIP.SetUserAgentSIP(sUserAgentName)
    End Function

    Public Function GetUserAgentSIP() As String
        Return m_objVaxVoIP.GetUserAgentSIP()
    End Function

    Public Function SetSubjectSDP(ByVal sSubjectSDP As String) As Boolean
        Return m_objVaxVoIP.SetSubjectSDP(sSubjectSDP)
    End Function

    Public Function GetSubjectSDP() As String
        Return m_objVaxVoIP.GetSubjectSDP()
    End Function

    Public Function ConfAllowLine(ByVal nLineNo As Integer, ByVal bAllowListen As Boolean, ByVal bAllowSpeak As Boolean) As Boolean
        Return m_objVaxVoIP.ConfAllowLine(nLineNo, bAllowListen, bAllowSpeak)
    End Function

    Public Function LineVoiceChannelSpk(ByVal nLineNo As Integer, ByVal nChannel As Integer) As Boolean
        Return m_objVaxVoIP.LineVoiceChannelSpk(nLineNo, nChannel)
    End Function

    Public Function ChatFindContact(ByVal sAccountName As String, ByVal sUserName As String) As Boolean
        Return m_objVaxVoIP.ChatFindContact(sAccountName, sUserName)
    End Function

    Public Function ChatAddContact(ByVal sAccountName As String, ByVal sUserName As String, ByVal bPresence As Boolean) As Boolean
        Return m_objVaxVoIP.ChatAddContact(sAccountName, sUserName, bPresence)
    End Function

    Public Function ChatRemoveContact(ByVal sAccountName As String, ByVal sUserName As String) As Boolean
        Return m_objVaxVoIP.ChatRemoveContact(sAccountName, sUserName)
    End Function

    Public Function ChatSendMessageTyping(ByVal sAccountName As String, ByVal sUserName As String, ByVal nUserValue As Long) As Boolean
        Return m_objVaxVoIP.ChatSendMessageTyping(sAccountName, sUserName, nUserValue)
    End Function

    Public Function ChatSendMessageText(ByVal sAccountName As String, ByVal sUserName As String, ByVal sMsgText As String, ByVal bMsgTypeHtml As Boolean, ByVal nUserValue As Long) As Boolean
        Return m_objVaxVoIP.ChatSendMessageText(sAccountName, sUserName, sMsgText, bMsgTypeHtml, nUserValue)
    End Function

    Public Function ChatSetMyStatus(ByVal sAccountName As String, ByVal nStatusId As Integer) As Boolean
        Return m_objVaxVoIP.ChatSetMyStatus(sAccountName, nStatusId)
    End Function

    Public Function VoiceChanger(ByVal nPitch As Integer) As Boolean
        Return m_objVaxVoIP.VoiceChanger(nPitch)
    End Function

    Public Function ForwardCall(ByVal bEnable As Boolean, ByVal sToUserName As String) As Boolean
        Return m_objVaxVoIP.ForwardCall(bEnable, sToUserName)
    End Function

    Public Function PlayAddPCM(ByVal nLineNo As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer) As Boolean
        Dim hHandleGC As GCHandle = GCHandle.Alloc(aDataPCM, GCHandleType.Pinned)
        Dim AddrDataPCM As IntPtr = hHandleGC.AddrOfPinnedObject()
        Dim nDataPCM As Integer = AddrDataPCM.ToInt32()
        Dim bResult As Boolean = m_objVaxVoIP.PlayAddPCM(nLineNo, nDataPCM, nSizePCM)
        hHandleGC.Free()
        Return bResult
    End Function

    Public Function PlayResetPCM(ByVal nLineNo As Integer) As Boolean
        Return m_objVaxVoIP.PlayResetPCM(nLineNo)
    End Function

    Public Function DetectAMD(ByVal nLineNo As Integer, ByVal bEnable As Boolean, ByVal nAnalysisTime As Integer, ByVal nSilenceTime As Integer, ByVal nSilenceCount As Integer) As Boolean
        Return m_objVaxVoIP.DetectAMD(nLineNo, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount)
    End Function

    Public Function AddCustomHeader(ByVal nLineNo As Integer, ByVal nReqId As Integer, ByVal sName As String, ByVal sValue As String) As Boolean
        Return m_objVaxVoIP.AddCustomHeader(nLineNo, nReqId, sName, sValue)
    End Function

    Public Function RemoveCustomHeader(ByVal nLineNo As Integer, ByVal nReqId As Integer, ByVal sName As String) As Boolean
        Return m_objVaxVoIP.RemoveCustomHeader(nLineNo, nReqId, sName)
    End Function

    Public Function RemoveCustomHeaderAll(ByVal nLineNo As Integer, ByVal nReqId As Integer) As Boolean
        Return m_objVaxVoIP.RemoveCustomHeaderAll(nLineNo, nReqId)
    End Function

    Public Function GetCountPacketLost(ByVal nLineNo As Integer) As Integer
        Return m_objVaxVoIP.GetCountPacketLost(nLineNo)
    End Function

    Public Function GetSizeJitterBuffer(ByVal nLineNo As Integer) As Integer
        Return m_objVaxVoIP.GetSizeJitterBuffer(nLineNo)
    End Function

    Public Function OpenMediaSecondry(ByVal nInputDeviceId As Integer, ByVal nOutputDeviceId As Integer) As Boolean
        Return m_objVaxVoIP.OpenMediaSecondry(nInputDeviceId, nOutputDeviceId)
    End Function

    Public Function CloseMediaSecondry() As Boolean
        Return m_objVaxVoIP.CloseMediaSecondry()
    End Function

    Public Function ChangeMEDIA(ByVal nLineNo As Integer, ByVal nInputDeviceId As Integer, ByVal nOutputDeviceId As Integer) As Boolean
        Return m_objVaxVoIP.ChangeMEDIA(nLineNo, nInputDeviceId, nOutputDeviceId)
    End Function

    Public Function GetVideoDevTotal() As Integer
        Return m_objVaxVoIP.GetVideoDevTotal()
    End Function

    Public Function GetVideoDevName(ByVal nDeviceId As Integer) As String
        Return m_objVaxVoIP.GetVideoDevName(nDeviceId)
    End Function

    Public Function OpenVideoDev(ByVal nDeviceId As Integer, ByVal nQuality As Integer) As Boolean
        Return m_objVaxVoIP.OpenVideoDev(nDeviceId, nQuality)
    End Function

    Public Sub CloseVideoDev()
        m_objVaxVoIP.CloseVideoDev()
    End Sub

    Public Function CryptoMediaNONE(ByVal bForced As Boolean) As Boolean
        Return m_objVaxVoIP.CryptoMediaNONE(bForced)
    End Function

    Public Function CryptoMediaSDP(ByVal bForced As Boolean) As Boolean
        Return m_objVaxVoIP.CryptoMediaSDP(bForced)
    End Function

    Public Function DialCallToREC(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal sDialNo As String) As Boolean
        Return m_objVaxVoIP.DialCallToREC(sAccountName, nLineNo, sDialNo)
    End Function

    Public Function DialRingEnable(ByVal sFileName As String) As Boolean
        Return m_objVaxVoIP.DialRingEnable(sFileName)
    End Function

    Public Function DialRingDisable() As Boolean
        Return m_objVaxVoIP.DialRingDisable()
    End Function

    Public Function BusyRingEnable(ByVal sFileName As String) As Boolean
        Return m_objVaxVoIP.BusyRingEnable(sFileName)
    End Function

    Public Function BusyRingDisable() As Boolean
        Return m_objVaxVoIP.BusyRingDisable()
    End Function

    Public Function EnableVideo(ByVal nLineNo As Integer, ByVal bOutbound As Boolean, ByVal bInbound As Boolean) As Boolean
        Return m_objVaxVoIP.EnableVideo(nLineNo, bOutbound, bInbound)
    End Function

    Public Function IsNetworkAvailable() As Boolean
        Return m_objVaxVoIP.IsNetworkAvailable()
    End Function

    Public Function NetworkReachability(ByVal bEnable As Boolean) As Boolean
        Return m_objVaxVoIP.NetworkReachability(bEnable)
    End Function

    Public Function AutoRegistration(ByVal sAccountName As String, ByVal bEnable As Boolean, ByVal nTickCountLimit As Integer, ByVal nTickSeconds As Integer) As Boolean
        Return m_objVaxVoIP.AutoRegistration(sAccountName, bEnable, nTickCountLimit, nTickSeconds)
    End Function

    Public Function VideoCodecBitRate(ByVal nCodecNo As Integer, ByVal nQuality As Integer) As Boolean
        Return m_objVaxVoIP.VideoCodecBitRate(nCodecNo, nQuality)
    End Function

    Public Function BusyLampGetContactStatus(ByVal sAccountName As String, ByVal sUserName As String) As Integer
        Return m_objVaxVoIP.BusyLampGetContactStatus(sAccountName, sUserName)
    End Function

    Public Function BusyLampFindContact(ByVal sAccountName As String, ByVal sUserName As String) As Boolean
        Return m_objVaxVoIP.BusyLampFindContact(sAccountName, sUserName)
    End Function

    Public Function BusyLampAddContact(ByVal sAccountName As String, ByVal sUserName As String) As Boolean
        Return m_objVaxVoIP.BusyLampAddContact(sAccountName, sUserName)
    End Function

    Public Function BusyLampRemoveContact(ByVal sAccountName As String, ByVal sUserName As String) As Boolean
        Return m_objVaxVoIP.BusyLampRemoveContact(sAccountName, sUserName)
    End Function

    Public Function BusyLampSubscribeContactAll(ByVal sAccountName As String) As Boolean
        Return m_objVaxVoIP.BusyLampSubscribeContactAll(sAccountName)
    End Function

    Public Function DiagnosticLogSIP(ByVal sAccountName As String, ByVal bInbound As Boolean, ByVal bOutbound As Boolean) As Boolean
        Return m_objVaxVoIP.DiagnosticLogSIP(sAccountName, bInbound, bOutbound)
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnInitialized()
    End Sub

    Public Overridable Sub OnUnInitialized()
    End Sub

    Public Overridable Sub OnConnectingToRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnTryingToRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnFailToRegister(ByVal sAccountName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnSuccessToRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnConnectingToReRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnTryingToReRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnFailToReRegister(ByVal sAccountName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnSuccessToReRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnTryingToUnRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnFailToUnRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnSuccessToUnRegister(ByVal sAccountName As String)
    End Sub

    Public Overridable Sub OnDialCallStarted(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String)
    End Sub

    Public Overridable Sub OnDialingCall(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnDialCallFailed(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContact As String)
    End Sub

    Public Overridable Sub OnConnectedCall(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal sToRTPIP As String, ByVal nToRTPPort As Integer)
    End Sub

    Public Overridable Sub OnHungupCall(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnIncomingCallStarted(ByVal sAccountName As String, ByVal sCallId As String, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sFromURI As String, ByVal sToURI As String)
    End Sub

    Public Overridable Sub OnIncomingCallEnded(ByVal sAccountName As String, ByVal sCallId As String, ByVal nReasonCode As Integer)
    End Sub

    Public Overridable Sub OnRingToneStarted(ByVal sAccountName As String, ByVal sCallId As String)
    End Sub

    Public Overridable Sub OnRingToneEnded(ByVal sAccountName As String, ByVal sCallId As String)
    End Sub

    Public Overridable Sub OnTransferCallAccepted(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnTransferCallFailed(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnPlayWaveDone(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnDigitDTMF(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal sDigit As String)
    End Sub

    Public Overridable Sub OnMsgNOTIFY(ByVal sAccountName As String, ByVal sMsg As String)
    End Sub

    Public Overridable Sub OnVoiceMailMsg(ByVal sAccountName As String, ByVal bIsMsgWaiting As Boolean, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal nNewUrgentMsgCount As Integer, ByVal nOldUrgentMsgCount As Integer, ByVal sMsgAccount As String)
    End Sub

    Public Overridable Sub OnIncomingDiagnostic(ByVal sAccountName As String, ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnOutgoingDiagnostic(ByVal sAccountName As String, ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer)
    End Sub

    Public Overridable Sub OnAudioSessionLost(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnSuccessToHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnTryingToHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnFailToHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnSuccessToUnHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnTryingToUnHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnFailToUnHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnTryingToRefresh(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnFailToRefresh(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnSuccessToRefresh(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnChatSubscribeSuccess(ByVal sAccountName As String, ByVal sUserName As String)
    End Sub

    Public Overridable Sub OnChatSubscribeFailed(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnChatContactStatus(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusId As Integer)
    End Sub

    Public Overridable Sub OnChatSendMsgTextSuccess(ByVal sAccountName As String, ByVal sUserName As String, ByVal sMsgText As String, ByVal nUserValue As Long)
    End Sub

    Public Overridable Sub OnChatSendMsgTextFailed(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sMsgText As String, ByVal nUserValue As Long)
    End Sub

    Public Overridable Sub OnChatSendMsgTypingSuccess(ByVal sAccountName As String, ByVal sUserName As String, ByVal nUserValue As Long)
    End Sub

    Public Overridable Sub OnChatSendMsgTypingFailed(ByVal sAccountName As String, ByVal sUserName As String, ByVal sStatusCode As Integer, ByVal sReasonPhrase As String, ByVal nUserValue As Long)
    End Sub

    Public Overridable Sub OnChatRecvMsgText(ByVal sAccountName As String, ByVal sUserName As String, ByVal sMsgText As String, ByVal bIsChatContact As Boolean)
    End Sub

    Public Overridable Sub OnChatRecvMsgTypingStart(ByVal sAccountName As String, ByVal sUserName As String)
    End Sub

    Public Overridable Sub OnChatRecvMsgTypingStop(ByVal sAccountName As String, ByVal sUserName As String)
    End Sub

    Public Overridable Sub OnDetectedAMD(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal bIsHuman As Boolean)
    End Sub

    Public Overridable Sub OnHoldCall(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnUnHoldCall(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub OnVideoDeviceFrameRGB(ByVal nDeviceId As Integer, ByVal lFrameRGB As Long, ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)

        Dim aFrameRGB As Byte() = New Byte(nFrameSize - 1) {}
        Marshal.Copy(New IntPtr(lFrameRGB), aFrameRGB, 0, nFrameSize)

        OnVideoDeviceFrameRGB(nDeviceId, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)

    End Sub

    Public Overridable Sub OnVideoDeviceFrameRGB(ByVal nDeviceId As Integer, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub OnVideoRemoteFrameRGB(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal lFrameRGB As Long, ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)

        Dim aFrameRGB As Byte() = New Byte(nFrameSize - 1) {}
        Marshal.Copy(New IntPtr(lFrameRGB), aFrameRGB, 0, nFrameSize)

        OnVideoRemoteFrameRGB(sAccountName, nLineNo, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)

    End Sub

    Public Overridable Sub OnVideoRemoteFrameRGB(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)
    End Sub

    Public Overridable Sub OnVideoRemoteStarted(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    Public Overridable Sub OnVideoRemoteEnded(ByVal sAccountName As String, ByVal nLineNo As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnAddCallHistory(ByVal sAccountName As String, ByVal bOutboundCallType As Boolean, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal lStartTime As ULong, ByVal lEndTime As ULong, ByVal lDuration As ULong, ByVal lDayNo As ULong, ByVal nHistoryTypeId As Integer)
    End Sub

    Public Overridable Sub OnNetworkReachability(ByVal bAvailable As Boolean)
    End Sub

    Public Overridable Sub OnAudioDeviceMicVU(ByVal nLevelVU As Integer)
    End Sub

    Public Overridable Sub OnAudioDeviceSpkVU(ByVal nLevelVU As Integer)
    End Sub

    Public Overridable Sub OnVaxErrorMsg(ByVal sFuncName As String, ByVal sErrorMsg As String, ByVal nErrorCode As Integer)
    End Sub

    Public Overridable Sub OnBusyLampSubscribeSuccess(ByVal sAccountName As String, ByVal sUserName As String)
    End Sub

    Public Overridable Sub OnBusyLampSubscribeFailed(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnBusyLampContactStatus(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusId As Integer)
    End Sub

    Public Overridable Sub OnAudioRecordedPCM(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
    End Sub
End Class
